// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: reservemodule/reservemodule.proto

package openfmb.reservemodule;

/**
 * <pre>
 * MISSING DOCUMENTATION!!!
 * </pre>
 *
 * Protobuf type {@code reservemodule.AllocatedMargin}
 */
public final class AllocatedMargin extends
    com.google.protobuf.GeneratedMessageV3 implements
    // @@protoc_insertion_point(message_implements:reservemodule.AllocatedMargin)
    AllocatedMarginOrBuilder {
private static final long serialVersionUID = 0L;
  // Use AllocatedMargin.newBuilder() to construct.
  private AllocatedMargin(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
    super(builder);
  }
  private AllocatedMargin() {
    requestID_ = "";
  }

  @java.lang.Override
  @SuppressWarnings({"unused"})
  protected java.lang.Object newInstance(
      UnusedPrivateParameter unused) {
    return new AllocatedMargin();
  }

  public static final com.google.protobuf.Descriptors.Descriptor
      getDescriptor() {
    return openfmb.reservemodule.Reservemodule.internal_static_reservemodule_AllocatedMargin_descriptor;
  }

  @java.lang.Override
  protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internalGetFieldAccessorTable() {
    return openfmb.reservemodule.Reservemodule.internal_static_reservemodule_AllocatedMargin_fieldAccessorTable
        .ensureFieldAccessorsInitialized(
            openfmb.reservemodule.AllocatedMargin.class, openfmb.reservemodule.AllocatedMargin.Builder.class);
  }

  public static final int REQUESTID_FIELD_NUMBER = 1;
  @SuppressWarnings("serial")
  private volatile java.lang.Object requestID_ = "";
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>string requestID = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   * @return The requestID.
   */
  @java.lang.Override
  public java.lang.String getRequestID() {
    java.lang.Object ref = requestID_;
    if (ref instanceof java.lang.String) {
      return (java.lang.String) ref;
    } else {
      com.google.protobuf.ByteString bs = 
          (com.google.protobuf.ByteString) ref;
      java.lang.String s = bs.toStringUtf8();
      requestID_ = s;
      return s;
    }
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>string requestID = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   * @return The bytes for requestID.
   */
  @java.lang.Override
  public com.google.protobuf.ByteString
      getRequestIDBytes() {
    java.lang.Object ref = requestID_;
    if (ref instanceof java.lang.String) {
      com.google.protobuf.ByteString b = 
          com.google.protobuf.ByteString.copyFromUtf8(
              (java.lang.String) ref);
      requestID_ = b;
      return b;
    } else {
      return (com.google.protobuf.ByteString) ref;
    }
  }

  public static final int ALLOCATEDMARGIN_FIELD_NUMBER = 2;
  private openfmb.reservemodule.ReserveMargin allocatedMargin_;
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.reservemodule.ReserveMargin allocatedMargin = 2;</code>
   * @return Whether the allocatedMargin field is set.
   */
  @java.lang.Override
  public boolean hasAllocatedMargin() {
    return allocatedMargin_ != null;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.reservemodule.ReserveMargin allocatedMargin = 2;</code>
   * @return The allocatedMargin.
   */
  @java.lang.Override
  public openfmb.reservemodule.ReserveMargin getAllocatedMargin() {
    return allocatedMargin_ == null ? openfmb.reservemodule.ReserveMargin.getDefaultInstance() : allocatedMargin_;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.reservemodule.ReserveMargin allocatedMargin = 2;</code>
   */
  @java.lang.Override
  public openfmb.reservemodule.ReserveMarginOrBuilder getAllocatedMarginOrBuilder() {
    return allocatedMargin_ == null ? openfmb.reservemodule.ReserveMargin.getDefaultInstance() : allocatedMargin_;
  }

  public static final int ALLOCATEDSTANDBYMARGIN_FIELD_NUMBER = 3;
  private openfmb.reservemodule.ReserveMargin allocatedStandbyMargin_;
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.reservemodule.ReserveMargin allocatedStandbyMargin = 3;</code>
   * @return Whether the allocatedStandbyMargin field is set.
   */
  @java.lang.Override
  public boolean hasAllocatedStandbyMargin() {
    return allocatedStandbyMargin_ != null;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.reservemodule.ReserveMargin allocatedStandbyMargin = 3;</code>
   * @return The allocatedStandbyMargin.
   */
  @java.lang.Override
  public openfmb.reservemodule.ReserveMargin getAllocatedStandbyMargin() {
    return allocatedStandbyMargin_ == null ? openfmb.reservemodule.ReserveMargin.getDefaultInstance() : allocatedStandbyMargin_;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.reservemodule.ReserveMargin allocatedStandbyMargin = 3;</code>
   */
  @java.lang.Override
  public openfmb.reservemodule.ReserveMarginOrBuilder getAllocatedStandbyMarginOrBuilder() {
    return allocatedStandbyMargin_ == null ? openfmb.reservemodule.ReserveMargin.getDefaultInstance() : allocatedStandbyMargin_;
  }

  private byte memoizedIsInitialized = -1;
  @java.lang.Override
  public final boolean isInitialized() {
    byte isInitialized = memoizedIsInitialized;
    if (isInitialized == 1) return true;
    if (isInitialized == 0) return false;

    memoizedIsInitialized = 1;
    return true;
  }

  @java.lang.Override
  public void writeTo(com.google.protobuf.CodedOutputStream output)
                      throws java.io.IOException {
    if (!com.google.protobuf.GeneratedMessageV3.isStringEmpty(requestID_)) {
      com.google.protobuf.GeneratedMessageV3.writeString(output, 1, requestID_);
    }
    if (allocatedMargin_ != null) {
      output.writeMessage(2, getAllocatedMargin());
    }
    if (allocatedStandbyMargin_ != null) {
      output.writeMessage(3, getAllocatedStandbyMargin());
    }
    getUnknownFields().writeTo(output);
  }

  @java.lang.Override
  public int getSerializedSize() {
    int size = memoizedSize;
    if (size != -1) return size;

    size = 0;
    if (!com.google.protobuf.GeneratedMessageV3.isStringEmpty(requestID_)) {
      size += com.google.protobuf.GeneratedMessageV3.computeStringSize(1, requestID_);
    }
    if (allocatedMargin_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(2, getAllocatedMargin());
    }
    if (allocatedStandbyMargin_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(3, getAllocatedStandbyMargin());
    }
    size += getUnknownFields().getSerializedSize();
    memoizedSize = size;
    return size;
  }

  @java.lang.Override
  public boolean equals(final java.lang.Object obj) {
    if (obj == this) {
     return true;
    }
    if (!(obj instanceof openfmb.reservemodule.AllocatedMargin)) {
      return super.equals(obj);
    }
    openfmb.reservemodule.AllocatedMargin other = (openfmb.reservemodule.AllocatedMargin) obj;

    if (!getRequestID()
        .equals(other.getRequestID())) return false;
    if (hasAllocatedMargin() != other.hasAllocatedMargin()) return false;
    if (hasAllocatedMargin()) {
      if (!getAllocatedMargin()
          .equals(other.getAllocatedMargin())) return false;
    }
    if (hasAllocatedStandbyMargin() != other.hasAllocatedStandbyMargin()) return false;
    if (hasAllocatedStandbyMargin()) {
      if (!getAllocatedStandbyMargin()
          .equals(other.getAllocatedStandbyMargin())) return false;
    }
    if (!getUnknownFields().equals(other.getUnknownFields())) return false;
    return true;
  }

  @java.lang.Override
  public int hashCode() {
    if (memoizedHashCode != 0) {
      return memoizedHashCode;
    }
    int hash = 41;
    hash = (19 * hash) + getDescriptor().hashCode();
    hash = (37 * hash) + REQUESTID_FIELD_NUMBER;
    hash = (53 * hash) + getRequestID().hashCode();
    if (hasAllocatedMargin()) {
      hash = (37 * hash) + ALLOCATEDMARGIN_FIELD_NUMBER;
      hash = (53 * hash) + getAllocatedMargin().hashCode();
    }
    if (hasAllocatedStandbyMargin()) {
      hash = (37 * hash) + ALLOCATEDSTANDBYMARGIN_FIELD_NUMBER;
      hash = (53 * hash) + getAllocatedStandbyMargin().hashCode();
    }
    hash = (29 * hash) + getUnknownFields().hashCode();
    memoizedHashCode = hash;
    return hash;
  }

  public static openfmb.reservemodule.AllocatedMargin parseFrom(
      java.nio.ByteBuffer data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.reservemodule.AllocatedMargin parseFrom(
      java.nio.ByteBuffer data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.reservemodule.AllocatedMargin parseFrom(
      com.google.protobuf.ByteString data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.reservemodule.AllocatedMargin parseFrom(
      com.google.protobuf.ByteString data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.reservemodule.AllocatedMargin parseFrom(byte[] data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.reservemodule.AllocatedMargin parseFrom(
      byte[] data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.reservemodule.AllocatedMargin parseFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.reservemodule.AllocatedMargin parseFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.reservemodule.AllocatedMargin parseDelimitedFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input);
  }
  public static openfmb.reservemodule.AllocatedMargin parseDelimitedFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.reservemodule.AllocatedMargin parseFrom(
      com.google.protobuf.CodedInputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.reservemodule.AllocatedMargin parseFrom(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }

  @java.lang.Override
  public Builder newBuilderForType() { return newBuilder(); }
  public static Builder newBuilder() {
    return DEFAULT_INSTANCE.toBuilder();
  }
  public static Builder newBuilder(openfmb.reservemodule.AllocatedMargin prototype) {
    return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
  }
  @java.lang.Override
  public Builder toBuilder() {
    return this == DEFAULT_INSTANCE
        ? new Builder() : new Builder().mergeFrom(this);
  }

  @java.lang.Override
  protected Builder newBuilderForType(
      com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
    Builder builder = new Builder(parent);
    return builder;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * Protobuf type {@code reservemodule.AllocatedMargin}
   */
  public static final class Builder extends
      com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
      // @@protoc_insertion_point(builder_implements:reservemodule.AllocatedMargin)
      openfmb.reservemodule.AllocatedMarginOrBuilder {
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return openfmb.reservemodule.Reservemodule.internal_static_reservemodule_AllocatedMargin_descriptor;
    }

    @java.lang.Override
    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return openfmb.reservemodule.Reservemodule.internal_static_reservemodule_AllocatedMargin_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              openfmb.reservemodule.AllocatedMargin.class, openfmb.reservemodule.AllocatedMargin.Builder.class);
    }

    // Construct using openfmb.reservemodule.AllocatedMargin.newBuilder()
    private Builder() {

    }

    private Builder(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      super(parent);

    }
    @java.lang.Override
    public Builder clear() {
      super.clear();
      bitField0_ = 0;
      requestID_ = "";
      allocatedMargin_ = null;
      if (allocatedMarginBuilder_ != null) {
        allocatedMarginBuilder_.dispose();
        allocatedMarginBuilder_ = null;
      }
      allocatedStandbyMargin_ = null;
      if (allocatedStandbyMarginBuilder_ != null) {
        allocatedStandbyMarginBuilder_.dispose();
        allocatedStandbyMarginBuilder_ = null;
      }
      return this;
    }

    @java.lang.Override
    public com.google.protobuf.Descriptors.Descriptor
        getDescriptorForType() {
      return openfmb.reservemodule.Reservemodule.internal_static_reservemodule_AllocatedMargin_descriptor;
    }

    @java.lang.Override
    public openfmb.reservemodule.AllocatedMargin getDefaultInstanceForType() {
      return openfmb.reservemodule.AllocatedMargin.getDefaultInstance();
    }

    @java.lang.Override
    public openfmb.reservemodule.AllocatedMargin build() {
      openfmb.reservemodule.AllocatedMargin result = buildPartial();
      if (!result.isInitialized()) {
        throw newUninitializedMessageException(result);
      }
      return result;
    }

    @java.lang.Override
    public openfmb.reservemodule.AllocatedMargin buildPartial() {
      openfmb.reservemodule.AllocatedMargin result = new openfmb.reservemodule.AllocatedMargin(this);
      if (bitField0_ != 0) { buildPartial0(result); }
      onBuilt();
      return result;
    }

    private void buildPartial0(openfmb.reservemodule.AllocatedMargin result) {
      int from_bitField0_ = bitField0_;
      if (((from_bitField0_ & 0x00000001) != 0)) {
        result.requestID_ = requestID_;
      }
      if (((from_bitField0_ & 0x00000002) != 0)) {
        result.allocatedMargin_ = allocatedMarginBuilder_ == null
            ? allocatedMargin_
            : allocatedMarginBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000004) != 0)) {
        result.allocatedStandbyMargin_ = allocatedStandbyMarginBuilder_ == null
            ? allocatedStandbyMargin_
            : allocatedStandbyMarginBuilder_.build();
      }
    }

    @java.lang.Override
    public Builder mergeFrom(com.google.protobuf.Message other) {
      if (other instanceof openfmb.reservemodule.AllocatedMargin) {
        return mergeFrom((openfmb.reservemodule.AllocatedMargin)other);
      } else {
        super.mergeFrom(other);
        return this;
      }
    }

    public Builder mergeFrom(openfmb.reservemodule.AllocatedMargin other) {
      if (other == openfmb.reservemodule.AllocatedMargin.getDefaultInstance()) return this;
      if (!other.getRequestID().isEmpty()) {
        requestID_ = other.requestID_;
        bitField0_ |= 0x00000001;
        onChanged();
      }
      if (other.hasAllocatedMargin()) {
        mergeAllocatedMargin(other.getAllocatedMargin());
      }
      if (other.hasAllocatedStandbyMargin()) {
        mergeAllocatedStandbyMargin(other.getAllocatedStandbyMargin());
      }
      this.mergeUnknownFields(other.getUnknownFields());
      onChanged();
      return this;
    }

    @java.lang.Override
    public final boolean isInitialized() {
      return true;
    }

    @java.lang.Override
    public Builder mergeFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      if (extensionRegistry == null) {
        throw new java.lang.NullPointerException();
      }
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            case 10: {
              requestID_ = input.readStringRequireUtf8();
              bitField0_ |= 0x00000001;
              break;
            } // case 10
            case 18: {
              input.readMessage(
                  getAllocatedMarginFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000002;
              break;
            } // case 18
            case 26: {
              input.readMessage(
                  getAllocatedStandbyMarginFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000004;
              break;
            } // case 26
            default: {
              if (!super.parseUnknownField(input, extensionRegistry, tag)) {
                done = true; // was an endgroup tag
              }
              break;
            } // default:
          } // switch (tag)
        } // while (!done)
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.unwrapIOException();
      } finally {
        onChanged();
      } // finally
      return this;
    }
    private int bitField0_;

    private java.lang.Object requestID_ = "";
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>string requestID = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @return The requestID.
     */
    public java.lang.String getRequestID() {
      java.lang.Object ref = requestID_;
      if (!(ref instanceof java.lang.String)) {
        com.google.protobuf.ByteString bs =
            (com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        requestID_ = s;
        return s;
      } else {
        return (java.lang.String) ref;
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>string requestID = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @return The bytes for requestID.
     */
    public com.google.protobuf.ByteString
        getRequestIDBytes() {
      java.lang.Object ref = requestID_;
      if (ref instanceof String) {
        com.google.protobuf.ByteString b = 
            com.google.protobuf.ByteString.copyFromUtf8(
                (java.lang.String) ref);
        requestID_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>string requestID = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @param value The requestID to set.
     * @return This builder for chaining.
     */
    public Builder setRequestID(
        java.lang.String value) {
      if (value == null) { throw new NullPointerException(); }
      requestID_ = value;
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>string requestID = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @return This builder for chaining.
     */
    public Builder clearRequestID() {
      requestID_ = getDefaultInstance().getRequestID();
      bitField0_ = (bitField0_ & ~0x00000001);
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>string requestID = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @param value The bytes for requestID to set.
     * @return This builder for chaining.
     */
    public Builder setRequestIDBytes(
        com.google.protobuf.ByteString value) {
      if (value == null) { throw new NullPointerException(); }
      checkByteStringIsUtf8(value);
      requestID_ = value;
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }

    private openfmb.reservemodule.ReserveMargin allocatedMargin_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.reservemodule.ReserveMargin, openfmb.reservemodule.ReserveMargin.Builder, openfmb.reservemodule.ReserveMarginOrBuilder> allocatedMarginBuilder_;
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.reservemodule.ReserveMargin allocatedMargin = 2;</code>
     * @return Whether the allocatedMargin field is set.
     */
    public boolean hasAllocatedMargin() {
      return ((bitField0_ & 0x00000002) != 0);
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.reservemodule.ReserveMargin allocatedMargin = 2;</code>
     * @return The allocatedMargin.
     */
    public openfmb.reservemodule.ReserveMargin getAllocatedMargin() {
      if (allocatedMarginBuilder_ == null) {
        return allocatedMargin_ == null ? openfmb.reservemodule.ReserveMargin.getDefaultInstance() : allocatedMargin_;
      } else {
        return allocatedMarginBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.reservemodule.ReserveMargin allocatedMargin = 2;</code>
     */
    public Builder setAllocatedMargin(openfmb.reservemodule.ReserveMargin value) {
      if (allocatedMarginBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        allocatedMargin_ = value;
      } else {
        allocatedMarginBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.reservemodule.ReserveMargin allocatedMargin = 2;</code>
     */
    public Builder setAllocatedMargin(
        openfmb.reservemodule.ReserveMargin.Builder builderForValue) {
      if (allocatedMarginBuilder_ == null) {
        allocatedMargin_ = builderForValue.build();
      } else {
        allocatedMarginBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.reservemodule.ReserveMargin allocatedMargin = 2;</code>
     */
    public Builder mergeAllocatedMargin(openfmb.reservemodule.ReserveMargin value) {
      if (allocatedMarginBuilder_ == null) {
        if (((bitField0_ & 0x00000002) != 0) &&
          allocatedMargin_ != null &&
          allocatedMargin_ != openfmb.reservemodule.ReserveMargin.getDefaultInstance()) {
          getAllocatedMarginBuilder().mergeFrom(value);
        } else {
          allocatedMargin_ = value;
        }
      } else {
        allocatedMarginBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.reservemodule.ReserveMargin allocatedMargin = 2;</code>
     */
    public Builder clearAllocatedMargin() {
      bitField0_ = (bitField0_ & ~0x00000002);
      allocatedMargin_ = null;
      if (allocatedMarginBuilder_ != null) {
        allocatedMarginBuilder_.dispose();
        allocatedMarginBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.reservemodule.ReserveMargin allocatedMargin = 2;</code>
     */
    public openfmb.reservemodule.ReserveMargin.Builder getAllocatedMarginBuilder() {
      bitField0_ |= 0x00000002;
      onChanged();
      return getAllocatedMarginFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.reservemodule.ReserveMargin allocatedMargin = 2;</code>
     */
    public openfmb.reservemodule.ReserveMarginOrBuilder getAllocatedMarginOrBuilder() {
      if (allocatedMarginBuilder_ != null) {
        return allocatedMarginBuilder_.getMessageOrBuilder();
      } else {
        return allocatedMargin_ == null ?
            openfmb.reservemodule.ReserveMargin.getDefaultInstance() : allocatedMargin_;
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.reservemodule.ReserveMargin allocatedMargin = 2;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.reservemodule.ReserveMargin, openfmb.reservemodule.ReserveMargin.Builder, openfmb.reservemodule.ReserveMarginOrBuilder> 
        getAllocatedMarginFieldBuilder() {
      if (allocatedMarginBuilder_ == null) {
        allocatedMarginBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.reservemodule.ReserveMargin, openfmb.reservemodule.ReserveMargin.Builder, openfmb.reservemodule.ReserveMarginOrBuilder>(
                getAllocatedMargin(),
                getParentForChildren(),
                isClean());
        allocatedMargin_ = null;
      }
      return allocatedMarginBuilder_;
    }

    private openfmb.reservemodule.ReserveMargin allocatedStandbyMargin_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.reservemodule.ReserveMargin, openfmb.reservemodule.ReserveMargin.Builder, openfmb.reservemodule.ReserveMarginOrBuilder> allocatedStandbyMarginBuilder_;
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.reservemodule.ReserveMargin allocatedStandbyMargin = 3;</code>
     * @return Whether the allocatedStandbyMargin field is set.
     */
    public boolean hasAllocatedStandbyMargin() {
      return ((bitField0_ & 0x00000004) != 0);
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.reservemodule.ReserveMargin allocatedStandbyMargin = 3;</code>
     * @return The allocatedStandbyMargin.
     */
    public openfmb.reservemodule.ReserveMargin getAllocatedStandbyMargin() {
      if (allocatedStandbyMarginBuilder_ == null) {
        return allocatedStandbyMargin_ == null ? openfmb.reservemodule.ReserveMargin.getDefaultInstance() : allocatedStandbyMargin_;
      } else {
        return allocatedStandbyMarginBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.reservemodule.ReserveMargin allocatedStandbyMargin = 3;</code>
     */
    public Builder setAllocatedStandbyMargin(openfmb.reservemodule.ReserveMargin value) {
      if (allocatedStandbyMarginBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        allocatedStandbyMargin_ = value;
      } else {
        allocatedStandbyMarginBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.reservemodule.ReserveMargin allocatedStandbyMargin = 3;</code>
     */
    public Builder setAllocatedStandbyMargin(
        openfmb.reservemodule.ReserveMargin.Builder builderForValue) {
      if (allocatedStandbyMarginBuilder_ == null) {
        allocatedStandbyMargin_ = builderForValue.build();
      } else {
        allocatedStandbyMarginBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.reservemodule.ReserveMargin allocatedStandbyMargin = 3;</code>
     */
    public Builder mergeAllocatedStandbyMargin(openfmb.reservemodule.ReserveMargin value) {
      if (allocatedStandbyMarginBuilder_ == null) {
        if (((bitField0_ & 0x00000004) != 0) &&
          allocatedStandbyMargin_ != null &&
          allocatedStandbyMargin_ != openfmb.reservemodule.ReserveMargin.getDefaultInstance()) {
          getAllocatedStandbyMarginBuilder().mergeFrom(value);
        } else {
          allocatedStandbyMargin_ = value;
        }
      } else {
        allocatedStandbyMarginBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.reservemodule.ReserveMargin allocatedStandbyMargin = 3;</code>
     */
    public Builder clearAllocatedStandbyMargin() {
      bitField0_ = (bitField0_ & ~0x00000004);
      allocatedStandbyMargin_ = null;
      if (allocatedStandbyMarginBuilder_ != null) {
        allocatedStandbyMarginBuilder_.dispose();
        allocatedStandbyMarginBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.reservemodule.ReserveMargin allocatedStandbyMargin = 3;</code>
     */
    public openfmb.reservemodule.ReserveMargin.Builder getAllocatedStandbyMarginBuilder() {
      bitField0_ |= 0x00000004;
      onChanged();
      return getAllocatedStandbyMarginFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.reservemodule.ReserveMargin allocatedStandbyMargin = 3;</code>
     */
    public openfmb.reservemodule.ReserveMarginOrBuilder getAllocatedStandbyMarginOrBuilder() {
      if (allocatedStandbyMarginBuilder_ != null) {
        return allocatedStandbyMarginBuilder_.getMessageOrBuilder();
      } else {
        return allocatedStandbyMargin_ == null ?
            openfmb.reservemodule.ReserveMargin.getDefaultInstance() : allocatedStandbyMargin_;
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.reservemodule.ReserveMargin allocatedStandbyMargin = 3;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.reservemodule.ReserveMargin, openfmb.reservemodule.ReserveMargin.Builder, openfmb.reservemodule.ReserveMarginOrBuilder> 
        getAllocatedStandbyMarginFieldBuilder() {
      if (allocatedStandbyMarginBuilder_ == null) {
        allocatedStandbyMarginBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.reservemodule.ReserveMargin, openfmb.reservemodule.ReserveMargin.Builder, openfmb.reservemodule.ReserveMarginOrBuilder>(
                getAllocatedStandbyMargin(),
                getParentForChildren(),
                isClean());
        allocatedStandbyMargin_ = null;
      }
      return allocatedStandbyMarginBuilder_;
    }
    @java.lang.Override
    public final Builder setUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.setUnknownFields(unknownFields);
    }

    @java.lang.Override
    public final Builder mergeUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.mergeUnknownFields(unknownFields);
    }


    // @@protoc_insertion_point(builder_scope:reservemodule.AllocatedMargin)
  }

  // @@protoc_insertion_point(class_scope:reservemodule.AllocatedMargin)
  private static final openfmb.reservemodule.AllocatedMargin DEFAULT_INSTANCE;
  static {
    DEFAULT_INSTANCE = new openfmb.reservemodule.AllocatedMargin();
  }

  public static openfmb.reservemodule.AllocatedMargin getDefaultInstance() {
    return DEFAULT_INSTANCE;
  }

  private static final com.google.protobuf.Parser<AllocatedMargin>
      PARSER = new com.google.protobuf.AbstractParser<AllocatedMargin>() {
    @java.lang.Override
    public AllocatedMargin parsePartialFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      Builder builder = newBuilder();
      try {
        builder.mergeFrom(input, extensionRegistry);
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(builder.buildPartial());
      } catch (com.google.protobuf.UninitializedMessageException e) {
        throw e.asInvalidProtocolBufferException().setUnfinishedMessage(builder.buildPartial());
      } catch (java.io.IOException e) {
        throw new com.google.protobuf.InvalidProtocolBufferException(e)
            .setUnfinishedMessage(builder.buildPartial());
      }
      return builder.buildPartial();
    }
  };

  public static com.google.protobuf.Parser<AllocatedMargin> parser() {
    return PARSER;
  }

  @java.lang.Override
  public com.google.protobuf.Parser<AllocatedMargin> getParserForType() {
    return PARSER;
  }

  @java.lang.Override
  public openfmb.reservemodule.AllocatedMargin getDefaultInstanceForType() {
    return DEFAULT_INSTANCE;
  }

}

